; Greg Lyon - 2005
.586
.MODEL FLAT, stdcall
option casemap:none

include \masm32\include\windows.inc

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc
include \masm32\include\msvcrt.inc

include \masm32\macros\macros.asm

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\msvcrt.lib

;; ----------------------------------------------
ubyte$ MACRO bytevalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%u", 0
    .code
        mov   al, bytevalue
        movzx eax, al
        push  eax
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sbyte$ MACRO sbytevalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%d", 0
    .code
        mov   al, sbytevalue
        movsx eax, al
        push  eax
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
uword$ MACRO wordvalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%hu", 0
    .code
        mov   ax, wordvalue
        movzx eax, ax
        push  eax
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sword$ MACRO swordvalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%hd", 0
    .code
        mov   ax, swordvalue
        movsx eax, ax
        push  eax
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
udword$ MACRO udwordvalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%lu", 0
    .code
        push  udwordvalue
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sdword$ MACRO sdwordvalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%ld", 0
    .code
        push  sdwordvalue
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
uqword$ MACRO uqwordvalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%I64u", 0
    .code
        push  DWORD PTR [uqwordvalue+0]
        push  DWORD PTR [uqwordvalue+4]
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sqword$ MACRO sqwordvalue:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%I64d", 0
    .code
        push  DWORD PTR [sqwordvalue+0]
        push  DWORD PTR [sqwordvalue+4]
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
real4$ MACRO r4value:req
    LOCAL r8value, buffer, fmt
    .data
        r8value REAL8 0.0
        buffer  BYTE 32 dup(0)
        fmt     BYTE "%lf", 0
    .code
        finit
        fld   r4value
        fstp  r8value
        fwait
        push  DWORD PTR [r8value+4]
        push  DWORD PTR [r8value+0]
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
real8$ MACRO r8value:req
    LOCAL buffer, fmt
    .data
        buffer BYTE 32 dup(0)
        fmt    BYTE "%lf", 0
    .code
        push  DWORD PTR [r8value+4]
        push  DWORD PTR [r8value+0]
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
real10$ MACRO r10value:req
    LOCAL r8value, buffer, fmt
    .data
        r8value REAL8 0.0
        buffer  BYTE 32 dup(0)
        fmt     BYTE "%lf", 0
    .code
        finit
        fld   r10value
        fstp  r8value
        fwait
        push  DWORD PTR [r8value+4]
        push  DWORD PTR [r8value+0]
        push  OFFSET fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
WaitKey MACRO
    LOCAL crlf, pak
    .data
        crlf BYTE 13, 10, 0
        pak  BYTE 13, 10, "Press any key to continue...", 0
    .code   
        push OFFSET pak
        call crt_printf
        add esp, 4
        call crt__getch
        .if (eax == 0) || (eax == 0E0h)
            call crt__getch
        .endif
        push OFFSET crlf
        call crt_printf
        add esp, 4
ENDM
;; ----------------------------------------------

.DATA

    byTest    BYTE   0FFh
    sbyTest   SBYTE  0FFh
    wdTest    WORD   0FFFFh
    swdTest   SWORD  0FFFFh
    dwTest    DWORD  0FFFFFFFFh
    sdwTest   SDWORD 0FFFFFFFFh
    qwTest    QWORD  0FFFFFFFFFFFFFFFFh
    sqwTest   QWORD  0FFFFFFFFFFFFFFFFh
    r4Test    REAL4  123.4567890
    r8Test    REAL8  456.7890123
    r10Test   REAL10 789.0123456
       
.CODE

start:
       
    invoke crt_puts, ubyte$(byTest)
    invoke crt_puts, sbyte$(sbyTest)
    invoke crt_puts, SADD(0)
    invoke crt_puts, uword$(wdTest)
    invoke crt_puts, sword$(swdTest)
    invoke crt_puts, SADD(0)
    invoke crt_puts, udword$(dwTest)
    invoke crt_puts, sdword$(sdwTest)
    invoke crt_puts, SADD(0)
    invoke crt_puts, uqword$(qwTest)
    invoke crt_puts, sqword$(sqwTest)
    invoke crt_puts, SADD(0)
    invoke crt_puts, real4$(r4Test)
    invoke crt_puts, real8$(r8Test)
    invoke crt_puts, real10$(r10Test)
       
    WaitKey
         
    invoke ExitProcess, 0

end start 